Index: java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 99)
@@ -38,10 +38,10 @@
 import org.apache.log4j.Logger;
 
-import com.framsticks.core.Mode;
 import com.framsticks.core.Path;
 import com.framsticks.core.Tree;
-import com.framsticks.core.TreeOperations;
-import com.framsticks.gui.view.TreeCellRenderer;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.gui.tree.MetaNode;
+import com.framsticks.gui.tree.TreeCellRenderer;
+import com.framsticks.gui.tree.TreeModel;
+import com.framsticks.gui.tree.TreeNode;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.FutureHandler;
@@ -126,5 +126,5 @@
 			@Override
 			public void valueChanged(TreeSelectionEvent e) {
-				chooseTreeNode(e.getNewLeadSelectionPath());
+				treeModel.chooseTreeNode(e.getNewLeadSelectionPath());
 			}
 		});
@@ -139,5 +139,5 @@
 			@Override
 			public void treeExpanded(TreeExpansionEvent e) {
-				loadChildren(treeModel.convertToPath(e.getPath()), false);
+				// loadChildren(treeModel.convertToPath(e.getPath()), false);
 			}
 		});
@@ -243,5 +243,5 @@
 			public void actionPerformed(ActionEvent actionEvent) {
 
-				loadPath(treeModel.convertToPath(jtree.getSelectionPath()), true);
+				treeModel.loadPath(treeModel.convertToPath(jtree.getSelectionPath()), true);
 			}
 		});
@@ -258,7 +258,7 @@
 		Tree tree = path.getTree();
 
-		log.info("trying mount: " + path);
+		log.debug("trying mount: " + path);
 		if (!tree.getAssignedRoot().isResolved()) {
-			tree.get(path, Mode.FETCH, new FutureHandler<Path>(this) {
+			tree.get(path, new FutureHandler<Path>(this) {
 
 				@Override
@@ -275,5 +275,5 @@
 		treeAtFrames.put(tree, e);
 
-		rootNode.getChildren().add(new TreeNode(tree.getAssignedRoot()));
+		rootNode.getChildren().add(new TreeNode(e, Path.to(tree, "/")));
 		e.rootNode = tree.getAssignedRoot();
 		treeModel.nodeStructureChanged(new TreePath(rootNode));
@@ -311,58 +311,11 @@
 	}
 
-	public void loadChildren(Path path, boolean reload) {
-		if (path == null) {
-			return;
+	public void updatePanelIfIsLeadSelection(TreePath treePath, Path path) {
+		assert isActive();
+		if (treePath.equals(jtree.getSelectionPath())) {
+			treeAtFrames.get(path.getTree()).useOrCreatePanel(treePath);
 		}
-		AccessInterface access = TreeOperations.bindAccess(path);
-
-		int count = access.getCompositeParamCount();
-		for (int i = 0; i < count; ++i) {
-			Path childPath = path.appendParam(access.getCompositeParam(i)).tryFindResolution();
-			loadPath(childPath, reload);
-		}
-
-	}
-
-	public void loadPath(Path path, boolean reload) {
-		if (path == null) {
-			return;
-		}
-		if (path.isResolved() && !reload) {
-			return;
-		}
-		path.getTree().get(path, Mode.FETCH, new FutureHandler<Path>(this) {
-			@Override
-			protected void result(Path result) {
-				final TreePath treePath = treeModel.convertToTreePath(result);
-
-				treeModel.nodeStructureChanged(treePath);
-				if (treePath.equals(jtree.getSelectionPath())) {
-					treeAtFrames.get(result.getTree()).useOrCreatePanel(treePath);
-				}
-			}
-		});
-	}
-
-	public void chooseTreeNode(final TreePath treePath) {
-		assert isActive();
-		if (treePath == null) {
-			return;
-		}
-		if (treeModel.isChanging()) {
-			return;
-		}
-
-		Path path = treeModel.convertToPath(treePath);
-		if (path == null) {
-			return;
-		}
-		path = path.assureResolved();
-		final Tree tree = path.getTree();
-
-		treeAtFrames.get(tree).useOrCreatePanel(treePath);
-		loadChildren(path, false);
-
-	}
+	}
+
 
 
@@ -420,4 +373,11 @@
 
 	/**
+	 * @return the jtree
+	 */
+	public JTree getJtree() {
+		return jtree;
+	}
+
+	/**
 	 * @return the treeModel
 	 */
@@ -426,3 +386,17 @@
 	}
 
+	/**
+	 * @return the rootNode
+	 */
+	public MetaNode getRootNode() {
+		return rootNode;
+	}
+
+	/**
+	 * @return the treeAtFrames
+	 */
+	public Map<Tree, TreeAtFrame> getTreeAtFrames() {
+		return treeAtFrames;
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/gui/Gui.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 99)
@@ -101,5 +101,5 @@
 
 	public static <P extends Param, C extends Control> void fillWithControls(ControlOwner owner, Collection<P> params, Map<P, C> components, Class<C> controlType) {
-		JPanel panel = owner.getPanel();
+		JPanel panel = owner.getPanelForControls();
 		for (P param : params) {
 			if (param.isUserHidden()) {
Index: java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/ModifiablePanel.java	(revision 99)
@@ -20,8 +20,10 @@
 	 * Pane to which components will be added.
 	 */
-	protected JPanel contentPanel;
 
-	final protected JLabel label;
-	final protected JButton applyButton;
+	protected final JLabel label;
+	protected final JButton applyButton;
+	protected final JPanel centerPanel;
+
+	protected Component contentComponent;
 
 	public ModifiablePanel(Panel.Parameters parameters) {
@@ -30,8 +32,4 @@
 
 
-		contentPanel = new JPanel();
-		contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.PAGE_AXIS));
-		JScrollPane scroll = new JScrollPane(contentPanel);
-		//scroll.setBorder(BorderFactory.createEtchedBorder());
 
 		JPanel pageEndPanel = new JPanel();
@@ -53,10 +51,11 @@
 
 		label = new JLabel();
-		JPanel centerPanel = new JPanel();
+		centerPanel = new JPanel();
 		centerPanel.setLayout(new BorderLayout());
 		centerPanel.add(Box.createHorizontalStrut(10), BorderLayout.LINE_START);
 		centerPanel.add(Box.createHorizontalStrut(10), BorderLayout.LINE_END);
 		centerPanel.add(label, BorderLayout.PAGE_START);
-		centerPanel.add(scroll, BorderLayout.CENTER);
+
+
 		centerPanel.add(pageEndPanel, BorderLayout.PAGE_END);
 
@@ -68,3 +67,8 @@
 	protected abstract void applyChanges();
 
+	protected void setupContentComponent(Component contentComponent) {
+		this.contentComponent = contentComponent;
+		centerPanel.add(contentComponent, BorderLayout.CENTER);
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/gui/ObjectPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 99)
@@ -29,6 +29,14 @@
 	final protected Map<ValueParam, ValueControl> valueControls = new IdentityHashMap<ValueParam, ValueControl>();
 
+	protected final JPanel contentPanel;
+	protected final JScrollPane scrollPane;
+
 	public ObjectPanel(Panel.Parameters parameters, Collection<Param> params) {
 		super(parameters);
+
+		contentPanel = new JPanel();
+		scrollPane = new JScrollPane(contentPanel);
+		contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.PAGE_AXIS));
+		setupContentComponent(scrollPane);
 
 		Gui.fillWithControls(this, params, components, Control.class);
@@ -102,5 +110,5 @@
 
 	@Override
-	public JPanel getPanel() {
+	public JPanel getPanelForControls() {
 		return contentPanel;
 	}
Index: java/main/src/main/java/com/framsticks/gui/Panel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 99)
@@ -22,4 +22,6 @@
 		public final TreeAtFrame treeAtFrame;
 		public final CompositeParam param;
+
+		/** Contained type FramsClass. */
 		public final FramsClass framsClass;
 
Index: java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 99)
@@ -8,4 +8,5 @@
 import com.framsticks.core.TreeOperations;
 import com.framsticks.gui.controls.ValueControl;
+import com.framsticks.gui.tree.TreeNode;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
Index: java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 99)
@@ -10,5 +10,4 @@
 import com.framsticks.communication.Response;
 import com.framsticks.communication.queries.ApplicationRequest;
-import com.framsticks.core.Mode;
 import com.framsticks.core.Path;
 import static com.framsticks.core.TreeOperations.*;
@@ -143,5 +142,5 @@
 
 				if (path.getTop().getParam() instanceof ListParam) {
-					tree.get(path, Mode.FETCH, new FutureHandler<Path>(ManagedConsole.this) {
+					tree.get(path, new FutureHandler<Path>(ManagedConsole.this) {
 						@Override
 						protected void result(Path result) {
Index: java/main/src/main/java/com/framsticks/gui/controls/Control.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 99)
@@ -6,5 +6,5 @@
 import javax.swing.JPanel;
 
-import com.framsticks.params.Flags;
+import com.framsticks.params.ParamFlags;
 import com.framsticks.params.Param;
 import com.framsticks.util.FramsticksException;
@@ -57,5 +57,5 @@
 
 	public final boolean isReadonly() {
-		return !userEnabled || param.hasFlag(Flags.READONLY);
+		return !userEnabled || param.hasFlag(ParamFlags.READONLY);
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 99)
@@ -9,5 +9,5 @@
 public interface ControlOwner extends ExceptionResultHandler {
 
-	public JPanel getPanel();
+	public JPanel getPanelForControls();
 	public TreePath getCurrentTreePath();
 	public Frame getFrame();
Index: java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 99)
@@ -86,5 +86,5 @@
 
 	@Override
-	public JPanel getPanel() {
+	public JPanel getPanelForControls() {
 		return this;
 	}
Index: java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 99)
@@ -4,8 +4,10 @@
 
 import com.framsticks.params.CastFailure;
-import com.framsticks.params.Flags;
+import com.framsticks.params.ParamFlags;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
+import com.framsticks.params.SetStateFlags;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.FlagsUtil;
 import com.framsticks.util.swing.TooltipConstructor;
 
@@ -33,5 +35,5 @@
 			.append("min", primitiveParam.getMin(Object.class))
 			.append("max", primitiveParam.getMax(Object.class))
-			.append("flags", Flags.write(primitiveParam.getFlags(), null))
+			.append("flags", FlagsUtil.write(ParamFlags.class, primitiveParam.getFlags(), null))
 			.append("group", primitiveParam.getGroup())
 			.append("extra", primitiveParam.getExtra())
@@ -70,5 +72,5 @@
 			ReassignResult<?> res = getParam().reassign(candidate, oldValue);
 			if (res.getFlags() != 0) {
-				log.warn("filter of param " + param + " failed: " + Flags.write(res.getFlags(), "0"));
+				log.warn("filter of param " + param + " failed: " + FlagsUtil.write(SetStateFlags.class, res.getFlags(), "0"));
 			}
 			return res.getValue();
Index: java/main/src/main/java/com/framsticks/gui/table/ColumnsConfig.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ColumnsConfig.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/table/ColumnsConfig.java	(revision 99)
@@ -0,0 +1,58 @@
+package com.framsticks.gui.table;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.lang.Delimeted;
+
+@FramsClassAnnotation
+public class ColumnsConfig {
+
+	protected final List<String> columnsNames = new ArrayList<>();
+
+	protected String className;
+
+	@ParamAnnotation(id = "columnsNames")
+	public void setColumnsNamesAsString(String columns) {
+		columnsNames.clear();
+		columnsNames.addAll(Arrays.asList(columns.split(" ")));
+	}
+
+	@ParamAnnotation(id = "columnsNames")
+	public String getColumnsNamesAsString() {
+		return new Delimeted<String>(" ", "").append(columnsNames.iterator()).build();
+	}
+
+	/**
+	 * @return the columnsNames
+	 */
+	public List<String> getColumnsNames() {
+		return columnsNames;
+	}
+
+	/**
+	 * @return the name
+	 */
+	@ParamAnnotation
+	public String getClassName() {
+		return className;
+	}
+
+	/**
+	 * @param name the name to set
+	 */
+	@ParamAnnotation
+	public void setClassName(String className) {
+		this.className = className;
+	}
+
+	@Override
+	public String toString() {
+		return "columns config for " + className + ": " + getColumnsNames();
+	}
+
+
+}
Index: java/main/src/main/java/com/framsticks/gui/table/ListPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ListPanel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/table/ListPanel.java	(revision 99)
@@ -0,0 +1,73 @@
+package com.framsticks.gui.table;
+
+
+import com.framsticks.gui.ModifiablePanel;
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.ListAccess;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Containers;
+
+import org.apache.log4j.Logger;
+
+import javax.swing.*;
+
+/**
+ * Panel contains table and allows to manages displaying columns.
+ */
+@SuppressWarnings("serial")
+public class ListPanel extends ModifiablePanel {
+
+	private static final Logger log = Logger.getLogger(ListPanel.class.getName());
+
+	protected final TableModel tableModel;
+	protected final JTable table;
+	protected final JScrollPane scrollPane;
+
+	public ListPanel(Parameters parameters, ListPanelProvider provider) {
+		super(parameters);
+
+		final ColumnsConfig config = provider.getColumnsConfigs().get(framsClass.getName());
+		log.debug("creating ListPanel for " + parameters.framsClass + " using config " + config);
+
+		tableModel = new TableModel();
+		if (config != null) {
+			for (String id : config.getColumnsNames()) {
+				tableModel.addColumn(framsClass.getParamEntry(id, PrimitiveParam.class));
+			}
+		} else {
+			for (PrimitiveParam<?> param : Containers.filterInstanceof(framsClass.getParamEntries(), PrimitiveParam.class)) {
+				if (provider.getMaximumColumnNumber() != null && tableModel.getColumnCount() >= provider.getMaximumColumnNumber()) {
+					break;
+				}
+				tableModel.addColumn(param);
+			}
+		}
+
+		table = new JTable(tableModel);
+		scrollPane = new JScrollPane(table);
+		setupContentComponent(scrollPane);
+
+		table.getTableHeader().setReorderingAllowed(false);
+		table.setColumnSelectionAllowed(false);
+		table.setCellSelectionEnabled(false);
+		table.setColumnSelectionAllowed(false);
+
+		this.revalidate();
+	}
+
+
+	@Override
+	protected void applyChanges() {
+	}
+
+	@Override
+	public void pullValuesFromLocalToUser(AccessInterface access) {
+		tableModel.attachSource(Casting.throwCast(ListAccess.class, access));
+	}
+
+	@Override
+	public String getTitle() {
+		return "List";
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/table/ListPanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ListPanelProvider.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/table/ListPanelProvider.java	(revision 99)
@@ -0,0 +1,57 @@
+package com.framsticks.gui.table;
+
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.Map;
+
+import com.framsticks.gui.Panel;
+import com.framsticks.gui.PanelProvider;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.types.ListParam;
+
+@FramsClassAnnotation
+public class ListPanelProvider implements PanelProvider {
+
+	protected final Map<String, ColumnsConfig> columnsConfigs = new HashMap<>();
+	/**
+ 	 *
+	 * That limit is honored only when no explicit ColumnsConfig object is found.
+	 */
+	protected Integer maximumColumnNumber = 5;
+
+	@Override
+	public Panel providePanel(Panel.Parameters parameters) {
+		if (parameters.param instanceof ListParam) {
+			return new ListPanel(parameters, this);
+		}
+		return null;
+	}
+
+	@AutoAppendAnnotation
+	public void addColumnsConfig(ColumnsConfig config) {
+		columnsConfigs.put(config.getClassName(), config);
+	}
+
+	/**
+	 * @return the columnsConfigs
+	 */
+	public Map<String, ColumnsConfig> getColumnsConfigs() {
+		return Collections.unmodifiableMap(columnsConfigs);
+	}
+
+	/**
+	 * @return the maximumColumnNumber
+	 */
+	public Integer getMaximumColumnNumber() {
+		return maximumColumnNumber;
+	}
+
+	/**
+	 * @param maximumColumnNumber the maximumColumnNumber to set
+	 */
+	public void setMaximumColumnNumber(Integer maximumColumnNumber) {
+		this.maximumColumnNumber = maximumColumnNumber;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/table/TableModel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/TableModel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/table/TableModel.java	(revision 99)
@@ -0,0 +1,107 @@
+package com.framsticks.gui.table;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.LinkedList;
+import java.util.List;
+
+import javax.swing.event.TableModelEvent;
+import javax.swing.event.TableModelListener;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.ListAccess;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.util.lang.Casting;
+
+public class TableModel implements javax.swing.table.TableModel {
+	private static final Logger log =
+		Logger.getLogger(TableModel.class);
+
+
+	protected List<TableModelListener> listeners = new LinkedList<>();
+	protected ListAccess access;
+	protected AccessInterface elementAccess;
+	protected final List<PrimitiveParam<?>> columnParams = new ArrayList<>();
+
+	protected void refreshAll() {
+		for (TableModelListener l : listeners) {
+			l.tableChanged(new TableModelEvent(this));
+		}
+
+	}
+
+	public void attachSource(ListAccess access) {
+		this.access = Casting.assertCast(ListAccess.class, access.cloneAccess().select(access.getSelected()));
+
+		this.elementAccess = this.access.getElementAccess().cloneAccess();
+		log.debug("attached " + access);
+		refreshAll();
+	}
+
+	@Override
+	public void addTableModelListener(TableModelListener listener) {
+		listeners.add(listener);
+	}
+
+	@Override
+	public Class<?> getColumnClass(int columnIndex) {
+		// log.debug("returning column type " + columnParams.get(columnIndex).getStorageType());
+		return columnParams.get(columnIndex).getStorageType();
+	}
+
+	@Override
+	public int getColumnCount() {
+		// log.debug("returning column count " + columnParams.size());
+		return columnParams.size();
+	}
+
+	@Override
+	public String getColumnName(int columnIndex) {
+		return columnParams.get(columnIndex).getName();
+	}
+
+	@Override
+	public int getRowCount() {
+		// log.debug("returning row count " + access.getParamCount());
+		return access.getParamCount();
+	}
+
+	@Override
+	public Object getValueAt(int rowIndex, int columnIndex) {
+		assert (rowIndex < access.getParamCount() && columnIndex < columnParams.size());
+
+		return elementAccess.select(access.get(rowIndex, Object.class)).get(columnParams.get(columnIndex), Object.class);
+	}
+
+	@Override
+	public boolean isCellEditable(int rowIndex, int columnIndex) {
+		return false;
+	}
+
+	@Override
+	public void removeTableModelListener(TableModelListener listener) {
+		listeners.remove(listener);
+	}
+
+	@Override
+	public void setValueAt(Object value, int rowIndex, int columnIndex) {
+		throw new UnsupportedOperationException().msg("setting value in table");
+
+	}
+
+	public void addColumn(PrimitiveParam<?> columnParam) {
+		log.debug("added " + columnParam);
+		columnParams.add(columnParam);
+	}
+
+	/**
+	 * @return the columnParams
+	 */
+	public List<PrimitiveParam<?>> getColumnParams() {
+		return Collections.unmodifiableList(columnParams);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/tree/AbstractNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/AbstractNode.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/AbstractNode.java	(revision 99)
@@ -0,0 +1,17 @@
+package com.framsticks.gui.tree;
+
+
+
+public abstract class AbstractNode {
+
+	public AbstractNode() {
+	}
+
+	public abstract int getChildCount();
+	public abstract AbstractNode getChild(int number);
+	public abstract int getIndexOfChild(AbstractNode child);
+
+	public abstract boolean isLeaf();
+	public abstract void render(TreeCellRenderer renderer);
+
+}
Index: java/main/src/main/java/com/framsticks/gui/tree/EmptyNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/EmptyNode.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/EmptyNode.java	(revision 99)
@@ -0,0 +1,50 @@
+package com.framsticks.gui.tree;
+
+
+import com.framsticks.gui.ImageProvider;
+import com.framsticks.params.CompositeParam;
+
+public class EmptyNode extends AbstractNode {
+
+	protected final CompositeParam param;
+
+	/**
+	 * @param param
+	 */
+	public EmptyNode(CompositeParam param) {
+		this.param = param;
+	}
+
+	@Override
+	public int getChildCount() {
+		return 0;
+	}
+
+	@Override
+	public AbstractNode getChild(int number) {
+		return null;
+	}
+
+	@Override
+	public int getIndexOfChild(AbstractNode child) {
+		return -1;
+	}
+
+	@Override
+	public boolean isLeaf() {
+		return true;
+	}
+
+	@Override
+	public void render(TreeCellRenderer renderer) {
+		renderer.setIcon(ImageProvider.loadImage(TreeCellRenderer.findIconName(param)));
+		renderer.setText(param.getId());
+		renderer.setToolTipText("?");
+	}
+
+	@Override
+	public String toString() {
+		return param.toString();
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/tree/MetaNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/MetaNode.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/MetaNode.java	(revision 99)
@@ -0,0 +1,67 @@
+package com.framsticks.gui.tree;
+
+import java.util.LinkedList;
+import java.util.List;
+
+
+import com.framsticks.gui.ImageProvider;
+
+public class MetaNode extends AbstractNode {
+
+	protected List<AbstractNode> children = new LinkedList<>();
+	protected String name = "meta node";
+
+	/**
+	 * @return the children
+	 */
+	public List<AbstractNode> getChildren() {
+		return children;
+	}
+
+	/**
+	 * @return the name
+	 */
+	public String getName() {
+		return name;
+	}
+
+	/**
+	 * @param name the name to set
+	 */
+	public void setName(String name) {
+		this.name = name;
+	}
+
+	@Override
+	public int getChildCount() {
+		return children.size();
+	}
+
+	@Override
+	public AbstractNode getChild(int number) {
+		return children.get(number);
+	}
+
+	@Override
+	public int getIndexOfChild(AbstractNode child) {
+		return children.indexOf(child);
+	}
+
+	@Override
+	public String toString() {
+		return name;
+	}
+
+	@Override
+	public boolean isLeaf() {
+		return false;
+	}
+
+	@Override
+	public void render(TreeCellRenderer renderer) {
+		renderer.setIcon(ImageProvider.loadImage(ImageProvider.SERVER));
+		renderer.setText(name);
+		renderer.setToolTipText("?");
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/tree/TreeCellRenderer.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeCellRenderer.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeCellRenderer.java	(revision 99)
@@ -0,0 +1,95 @@
+package com.framsticks.gui.tree;
+
+import java.awt.Component;
+
+import javax.swing.JTree;
+import javax.swing.tree.DefaultTreeCellRenderer;
+
+import com.framsticks.gui.ImageProvider;
+import com.framsticks.params.CompositeParam;
+
+/**
+ * Renderer of Tree. Sets appropriate icons for nodes.
+ */
+@SuppressWarnings("serial")
+public class TreeCellRenderer extends DefaultTreeCellRenderer {
+
+	public TreeCellRenderer() {
+
+		// setOpenIcon(ImageProvider.loadImage(ImageProvider.FOLDER_OPEN));
+		// setClosedIcon(ImageProvider.loadImage(ImageProvider.FOLDER_CLOSED));
+		// setLeafIcon(ImageProvider.loadImage(ImageProvider.NODE));
+	}
+
+	@Override
+	public Component getTreeCellRendererComponent(JTree tree, Object value,
+			boolean sel, boolean expanded, boolean leaf, int row,
+			boolean hasFocus) {
+
+		super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
+
+		if (value == null) {
+			setText("!null value");
+			return this;
+		}
+
+		if (!(value instanceof AbstractNode)) {
+			setIcon(ImageProvider.loadImage(ImageProvider.SERVER));
+			setText("framsticks");
+			return this;
+		}
+		((AbstractNode) value).render(this);
+
+		return this;
+	}
+
+	public static String findIconName(CompositeParam param) {
+		switch (param.getFramsTypeName()) {
+			case "o Server": return ImageProvider.SERVER;
+			case "o Simulator": return ImageProvider.SIMULATOR;
+			case "o CLI": return ImageProvider.CLI;
+			case "o World": return ImageProvider.WORLD;
+			case "o GenePools": return ImageProvider.GENEPOOLS;
+			case "l GenePool": return ImageProvider.SIMULATOR; //HERE
+			case "o GenePool": return ImageProvider.GENEPOOLS_GROUP; //HERE
+
+			case "o Populations": return ImageProvider.POPULATIONS;
+			case "l Population": return ImageProvider.SIMULATOR; ///HERE
+			case "o Population": return ImageProvider.POPULATION_GROUP;
+			case "o ExpParams": return ImageProvider.EXPERIMENT;
+			case "o stats": return ImageProvider.STATISTIC;
+			case "l Genotype uid": return ImageProvider.GENOTYPES_GROUP;
+			case "o Genotype": return ImageProvider.GENOTYPES;
+
+			case "o Part": return ImageProvider.PART;
+			case "o Joint": return ImageProvider.JOINT;
+			case "o NeuroDef": return ImageProvider.NEURON_DEF;
+			case "o NeuroConn": return ImageProvider.NEURON_DEF;
+
+			case "o MechPart": return ImageProvider.MECH_PART;
+			case "o MechJoint": return ImageProvider.MECH_JOINT;
+			case "o Neuro": return ImageProvider.NEURON;
+
+			case "l Part": return ImageProvider.PART_GROUP;
+			case "l Joint": return ImageProvider.JOINT_GROUP;
+			case "l NeuroDef": return ImageProvider.NEURON_DEF_GROUP;
+			case "l NeuroConn": return ImageProvider.NEURON_DEF_GROUP;
+
+			case "l MechPart": return ImageProvider.MECH_PART_GROUP;
+			case "l MechJoint": return ImageProvider.MECH_JOINT_GROUP;
+			case "l Neuro": return ImageProvider.NEURON_GROUP;
+
+			case "o Creature": return ImageProvider.CREATURE;
+			case "l Creature uid": return ImageProvider.CREATURES_GROUP;
+			case "l Event id": return ImageProvider.EVENT;
+			case "o Event": return ImageProvider.EVENT;
+
+		}
+
+
+		return ImageProvider.SERVER;
+	}
+
+
+
+}
